/*
 * Définition de la classe CommandeAiguille
 * Regroupant 1 aiguille, 1 inter et 2 leds
 */

#define  pas 50             // pas en millisecondes

class CommandeAiguille {
  Servo  objetServo;
  Bounce objetInter;
  byte   etatAutomate;      // 0 fixe, 1 bouge
  int    etatInter;         // O directe, 1 dévié
  int    taillePlage;       // pas utilisé pour le moment
  int    posMin;            // position droite
  int    posMax;            // position déviée
  int    posCourante;       // posotion courante
  int    delta;             // saut de position = pas
  int    pinServo;
  int    pinInter;
  int    pinLedDirecte;
  int    pinLedDeviee;
  unsigned long tempo;      // pour l'automate

public:
  CommandeAiguille() {      // constructeur
    etatAutomate = 0;
  }
  
  void SetpinServo(int p) { // définir la pin Servo
    pinServo = p;
  }
  void SetpinInter(int p) { // définir la pin Inter
    pinInter = p;
  }
  void SetpinLedDirecte(int p) { // définir la pin led
    pinLedDirecte = p;
  }
  void SetpinLedDeviee(int p) { // définir la pin led
    pinLedDeviee = p;
  }

  void SetPosMinMax (int pm, int PM) { //définir les butées
    posMin = pm;
    posMax = PM;
    
  }
  void InitCommandeAiguille() {                 // initialisations
    pinMode(pinInter,INPUT_PULLUP);
    pinMode(pinLedDirecte,OUTPUT);
    pinMode(pinLedDeviee,OUTPUT);
    objetInter.attach(pinInter); 
    objetInter.interval(50); 
    etatInter = digitalRead(pinInter);  
    digitalWrite(pinLedDirecte, !etatInter);
    digitalWrite(pinLedDeviee, etatInter);
    if (etatInter) posCourante = posMin; else posCourante = posMax;
    objetServo.writeMicroseconds(posCourante);  // position initiale en fonction de l'inter
    objetServo.attach(pinServo);                // attaches the servo on servo_pin to the servo object
  }

  void InterUpdate() {                    // test de l'inter
    if (objetInter.update( )) {           // 1 si changement sinon 0
      objetServo.attach(pinServo);
      etatInter = objetInter.read();
      digitalWrite(pinLedDirecte, !etatInter);
      digitalWrite(pinLedDeviee, etatInter);   
      //objetServo.attach(pinServo);
      if (etatInter==HIGH) {
        delta = -5;                         // position passe à droite
      } else {
        delta = +5;                         // position passe à devié
      }
      etatAutomate = 1;                     // en mouvement
      tempo = millis();
    }
  }

  void ServoUpdate() {                      // mouvement du servo
    if (etatAutomate == 1) {
      if ((tempo+pas) < millis())  {        // fin du pas de tempo        
        posCourante = posCourante + delta;
        objetServo.writeMicroseconds(posCourante);
        if ((posCourante <= posMin) || (posCourante >= posMax)) { // arret
          etatAutomate = 0;
          //objetServo.detach();
        } else {
          tempo = millis();
        }
      }
    }  
  }

}; // fin de la classe CommandeAiguille
